lwIP 2.1.2 Lightweight IP stack

Functions
ip6.c File Reference
`#include "lwip/opt.h"`
`#include "lwip/def.h"`
`#include "lwip/mem.h"`
`#include "lwip/netif.h"`
`#include "lwip/ip.h"`
`#include "lwip/ip6.h"`
`#include "lwip/ip6_addr.h"`
`#include "lwip/ip6_frag.h"`
`#include "lwip/icmp6.h"`
`#include "lwip/priv/raw_priv.h"`
`#include "lwip/udp.h"`
`#include "lwip/priv/tcp_priv.h"`
`#include "lwip/dhcp6.h"`
`#include "lwip/nd6.h"`
`#include "lwip/mld6.h"`
`#include "lwip/debug.h"`
`#include "lwip/stats.h"`
`#include "path/to/my/lwip_hooks.h"`

## Functions
struct netif * | ip6_route (const ip6_addr_t *src, const ip6_addr_t *dest)
const ip_addr_t * | ip6_select_source_address (struct netif *netif, const ip6_addr_t *dest)
err_t | ip6_input (struct pbuf *p, struct netif *inp)
err_t | ip6_output_if (struct pbuf *p, const ip6_addr_t *src, const ip6_addr_t *dest, u8_t hl, u8_t tc, u8_t nexth, struct netif *netif)
err_t | ip6_output_if_src (struct pbuf *p, const ip6_addr_t *src, const ip6_addr_t *dest, u8_t hl, u8_t tc, u8_t nexth, struct netif *netif)
err_t | ip6_output (struct pbuf *p, const ip6_addr_t *src, const ip6_addr_t *dest, u8_t hl, u8_t tc, u8_t nexth)
err_t | ip6_options_add_hbh_ra (struct pbuf *p, u8_t nexth, u8_t value)

## Detailed Description

IPv6 layer.

## Function Documentation

## ◆ ip6_input()

err_t ip6_input | ( | struct pbuf * | p,
|  | struct netif * | inp
| ) |  |

This function is called by the network interface device driver when an IPv6 packet is received. The function does the basic checks of the IP header such as packet size being at least larger than the header size etc. If the packet was not destined for us, the packet is forwarded (using ip6_forward).

Finally, the packet is sent to the upper layer protocol input function.

Parameters

  p | the received IPv6 packet (p->payload points to IPv6 header)
  inp | the netif on which this packet was received

Returns
  ERR_OK if the packet was processed (could return ERR_* if it wasn't processed, but currently always returns ERR_OK)

## ◆ ip6_options_add_hbh_ra()

err_t ip6_options_add_hbh_ra | ( | struct pbuf * | p,
|  | u8_t | nexth,
|  | u8_t | value
| ) |  |

Add a hop-by-hop options header with a router alert option and padding.

Used by MLD when sending a Multicast listener report/done message.

Parameters

  p | the packet to which we will prepend the options header
  nexth | the next header protocol number (e.g. IP6_NEXTH_ICMP6)
  value | the value of the router alert option data (e.g. IP6_ROUTER_ALERT_VALUE_MLD)

Returns
  ERR_OK if hop-by-hop header was added, ERR_* otherwise

## ◆ ip6_output()

err_t ip6_output | ( | struct pbuf * | p,
|  | const ip6_addr_t * | src,
|  | const ip6_addr_t * | dest,
|  | u8_t | hl,
|  | u8_t | tc,
|  | u8_t | nexth
| ) |  |

Simple interface to ip6_output_if. It finds the outgoing network interface and calls upon ip6_output_if to do the actual work.

Parameters

  p | the packet to send (p->payload points to the data, e.g. next protocol header; if dest == LWIP_IP_HDRINCL, p already includes an IPv6 header and p->payload points to that IPv6 header)
  src | the source IPv6 address to send from (if src == IP6_ADDR_ANY, an IP address of the netif is selected and used as source address. if src == NULL, IP6_ADDR_ANY is used as source)
  dest | the destination IPv6 address to send the packet to
  hl | the Hop Limit value to be set in the IPv6 header
  tc | the Traffic Class value to be set in the IPv6 header
  nexth | the Next Header to be set in the IPv6 header

Returns
  ERR_RTE if no route is found see ip_output_if() for more return values

## ◆ ip6_output_if()

err_t ip6_output_if | ( | struct pbuf * | p,
|  | const ip6_addr_t * | src,
|  | const ip6_addr_t * | dest,
|  | u8_t | hl,
|  | u8_t | tc,
|  | u8_t | nexth,
|  | struct netif * | netif
| ) |  |

Sends an IPv6 packet on a network interface. This function constructs the IPv6 header. If the source IPv6 address is NULL, the IPv6 "ANY" address is used as source (usually during network startup). If the source IPv6 address it IP6_ADDR_ANY, the most appropriate IPv6 address of the outgoing network interface is filled in as source address. If the destination IPv6 address is LWIP_IP_HDRINCL, p is assumed to already include an IPv6 header and p->payload points to it instead of the data.

Parameters

  p | the packet to send (p->payload points to the data, e.g. next protocol header; if dest == LWIP_IP_HDRINCL, p already includes an IPv6 header and p->payload points to that IPv6 header)
  src | the source IPv6 address to send from (if src == IP6_ADDR_ANY, an IP address of the netif is selected and used as source address. if src == NULL, IP6_ADDR_ANY is used as source) (src is possibly not properly zoned)
  dest | the destination IPv6 address to send the packet to (possibly not properly zoned)
  hl | the Hop Limit value to be set in the IPv6 header
  tc | the Traffic Class value to be set in the IPv6 header
  nexth | the Next Header to be set in the IPv6 header
  netif | the netif on which to send this packet

Returns
  ERR_OK if the packet was sent OK ERR_BUF if p doesn't have enough space for IPv6/LINK headers returns errors returned by netif->output_ip6

## ◆ ip6_output_if_src()

err_t ip6_output_if_src | ( | struct pbuf * | p,
|  | const ip6_addr_t * | src,
|  | const ip6_addr_t * | dest,
|  | u8_t | hl,
|  | u8_t | tc,
|  | u8_t | nexth,
|  | struct netif * | netif
| ) |  |

Same as ip6_output_if() but 'src' address is not replaced by netif address when it is 'any'.

## ◆ ip6_route()

struct netif* ip6_route | ( | const ip6_addr_t * | src,
|  | const ip6_addr_t * | dest
| ) |  |

Finds the appropriate network interface for a given IPv6 address. It tries to select a netif following a sequence of heuristics: 1) if there is only 1 netif, return it 2) if the destination is a zoned address, match its zone to a netif 3) if the either the source or destination address is a scoped address, match the source address's zone (if set) or address (if not) to a netif 4) tries to match the destination subnet to a configured address 5) tries to find a router-announced route 6) tries to match the (unscoped) source address to the netif 7) returns the default netif, if configured

Note that each of the two given addresses may or may not be properly zoned.

Parameters

  src | the source IPv6 address, if known
  dest | the destination IPv6 address for which to find the route

Returns
  the netif on which to send to reach dest